{$mode objfpc}

type CType=(space,symbol,endof);
var utf8char:array[1..6]of char=(#128,#224,#240,#248,#252,#254);

function readchar(var f:text):CType;
 var c,cnext:char; i:byte;
begin
 result:=endof;
 if eof then exit;
 result:=space;
 read(f,c); if c<=' ' then exit;
 result:=symbol;
 for i:=1 to 6 do begin
  if c<utf8char[i] then exit;
  read(f,cnext);
 end;
end;

function readword(var f:text):integer;
 var c:ctype;
begin
 result:=0;
 repeat // считываем лидирующие пробельные символы ...
  c:=readchar(f);
  if c=endof then exit; // ... пока не встретится конец файла
 until c=symbol; // ... или пока не встретится значащий символ
 repeat // считываем значащие символы 
  inc(result);
  c:=readchar(f);
  if c=endof then exit; // ... пока не встретится конец файла
 until c=space; // ... или пока не встретится пробельный символ
end;

function calc(var f:text; Width:integer):integer;
var
    cnt:integer=0; // длина одного слова
    strs:integer=0; // кол-во строк
    lens:integer=0; // длина текущей строки
begin
 lens:=readword(f);   // разместили в строке первое слово
 while true do begin // последовательно считываем слова
  cnt:=readword(f);   // считали очередное слово
  if cnt=0 then break; // выходим из цикла по окончанию исходных данных
  inc(cnt); // добавали к слову лидирующий пробел
  if (lens+cnt)<=Width then // если увеличение строки не даст переполнения
   inc(lens, cnt)       // то увеличиваем длину текущей строки на размер слова
  else begin     // иначе следует перейти на новую строку
   inc(strs);    // увеличили кол-во строк
   lens:=cnt-1;  // перевели слово в новую строку без лидирующего пробела
  end;
 end;
// если на выходе остались слова - плюсуем строку
 if lens>0 then inc(strs);
 result:=strs;
end;

var W:integer; // максимальное кол-во символов в строке
begin
 readln(input,W); // считали максимальное кол-во символов в строке
 writeln(output,calc(input,W));
end.


